<script>
	
	//imports
	import {json} from 'd3-fetch';
	import {onMount} from "svelte";
	import { axisBottom } from 'd3-axis';
	import { scaleLinear } from "d3-scale";
	import { select } from 'd3-selection';
  
	import Controls from "./_design_1_control.svelte";
	import Area from "./_design_1_plot.svelte";
  
  
	// Size and margins
	
	const width = 600;

	const height=700;
	const margin = { top: 10, right: 10, bottom: 10, left: 10 };
	const innerWidth = width - margin.left - margin.right;
	const innerHeight = height - margin.top - margin.bottom;
  
	//declare data
	let data = null;
	let buildings = [];
	let myscale = 'PerLine';
	let city = 'Chicago';
	let citydata=null;
  
  
	onMount(async () => {
	  data = await json("/data/hourly_heating_december.json");
	  buildings = [... new Set(data.map(d => d.buildingtype))]; 
  
	});
  
	function data_city(mydata,mycity) {
	  if(!data) {
		return
	  }
	  return mydata.filter(d => d.city == mycity)
	};
	$:citydata = data_city(data,city);
	$:city;
	$:myscale;
  
	//Axis
	const xScale =  scaleLinear()
	  .domain([1,31])
	  .range([0,400]);
  
	function xAxis(hdl) { axisBottom()
	.scale(xScale)(select(hdl))};
  
  </script>

  <div>    
	{#if !data}
	<p>Loading the data, please wait ...</p>
	{:else}
	<Controls bind:current_city={city} bind:current_scaling={myscale}/> 
	<svg {width} {height}>
	  <g transform="translate({margin.left}, {margin.top})">
		<!--  -->
		  {#each buildings as bd,i}
		  <g transform="translate(0,{30+i*40})">
			<Area bind:data={citydata} bind:type={bd} bind:scaling={myscale}/>  
		  </g>
		   
		  {/each}    
	  </g>
	  <g transform="translate({margin.left},{margin.top+innerHeight-20})" use:xAxis> 
	</svg>
	{/if}
  </div>
  
  
  <style>
	svg {
	  border: 1px solid black;
	  border-radius: 5px;
	}
  </style>
  